function [Z,V,x,r,beta, myPerfMeasure] = GMstab1(A_fun,P,Z,V,x,r,beta,tolabs, myPerfMeasure,xGlobal)
    s                   = size(P,2);
    r(:,2)              = A_fun( r(:,1) );
    [tau,beta]          = StabCoeffs(r,beta);
    x                   = x      + tau * r(:,1);
    r(:,1)              = r(:,1) - tau * r(:,2);
    if(beta < tolabs)
        return;
    end
    myPerfMeasure.stop();
    myPerfMeasure.read(xGlobal+x,beta);
    myPerfMeasure.resume();
    % qr extension of V1
    C                   = zeros(2*s,2*s);
    C(1:s,1:s)          = eye(s,s);
    for i=1:s
        % orthogonalise V0(:,i) against V1(:,j)
        for j=1:s
            C(j,s+i)            = V(:,j,2)' * V(:,i,1);
            V(:,i,1)            = V(:,i,1) - C(j,s+i) * V(:,j,2);
        end
        % orthogonalise V0(:,i) against V0(:,j)
        for j=1:(i-1)
            C(s+j,s+i)          = V(:,j,1)' * V(:,i,1);
            V(:,i,1)            = V(:,i,1) - C(s+j,s+i) * V(:,j,1);
        end
        C(s+i,s+i)          = norm( V(:,i,1) );
        V(:,i,1)            = 1/C(s+i,s+i) * V(:,i,1);
    end
    F                   = 1/tau * C(:,s+[1:s]) - C(:,1:s);              %#ok<NBRAK>
    [Qf,Rf]             = qr(F,0);
    [Qz,Z]              = lq(-Z/Rf);
    V(:,:,1)          	= [V(:,:,2),V(:,:,1)] * (Qf*Qz);
    [W,Y,H,Qh,Rh,x,r,beta, myPerfMeasure] ...
                        = pGMRESm(A_fun,P,Z,V(:,:,1),x,r(:,1),beta,s,tolabs, myPerfMeasure,xGlobal);
    myPerfMeasure.stop();
    myPerfMeasure.read(xGlobal+x,beta);
    myPerfMeasure.resume();
    if(beta < tolabs)
        return;
    end
    if( myPerfMeasure.isTerminate() )
        return;
    end
    gamma               = [beta; zeros(s,1)];
    eta                 = beta * Y(:,1);
    [Qz,Lz]             = lq(Y*Qh);
    xi                  = Rh \(Qz * (Lz\eta));
    x                   = x + W(:,1:s) * xi - V(:,:,1) * ( Z \ (Y(:,1:s)*xi) );
    c0                  = gamma - H * xi;
    beta                = norm(c0);
    V(:,:,1)          	= W(:,1: s   ) * (Rh\Qz) - V(:,:,1) * (Z\(Y(:,1:s)*(Rh\Qz)));   % // == [W(:,1:s),V0] * [I;-Z\Y(:,1:s)] * (Rh\Qz)
    V(:,:,2)          	= W(:,1:(s+1)) * (Qh*Qz);                                       % // == W(:,1:(s+1)) * H * (Rh\Qz) == W(:,1:(s+1)) * Qh* Rh * inv(Rh) * Qz
    r(:,1)              = W(:,1:(s+1)) * c0;
    Z                   = Lz;
    myPerfMeasure.stop();
    myPerfMeasure.read(xGlobal+x,beta);
    myPerfMeasure.resume();
end