function [P,V,Z,x,r,beta,myPerfMeasure] = Initialisation(A_fun,x0,r0,beta,s,tolabs,myPerfMeasure)
    N                       = size(r0,1);
    [x,r,beta,W,H,Qh,Rh,myPerfMeasure]...
                            = GMRESm(A_fun,x0,r0,beta,s,tolabs,myPerfMeasure);
    if( myPerfMeasure.isTerminate() )
        return;
    end
    rng('default');
    P                       = orth( randn(N,s) );
    Y                       = P' * W;
    eta                     = beta * Y(:,1);
    Z                       = Y * Qh;
    [Qz,Lz]                 = lq(Z);
    xi                      = Rh\( Qz * (Lz\eta) );
    gamma                   = [beta;zeros(s,1)];
    c0                      = gamma - H * xi;
    Z                       = Lz;
    x                       = x + W(:,1: s   ) * xi;
    r                       =     W(:,1:(s+1)) * c0;
    beta                    = norm(c0);
    V(:,:,1)                = W(:,1: s   ) * (Rh\Qz);
    V(:,:,2)             	= W(:,1:(s+1)) * (Qh*Qz);
    myPerfMeasure.read(x,beta);
end