function [tau,beta] = StabCoeffs(r,beta)
    % parameters
    alpha           = pi*7/36;    % 35 degrees
    % actual code
    L               = size(r,2)-1;
    S               = zeros(L+1,L+1);
    S(1,1)          = beta*beta;
    for i=2:(L+1);
        for j=1:i
            S(j,i)          = r(:,j)' * r(:,i);
        end
    end
    ds              = diag(S);
    S               = S - diag(ds);
    S               = S + S' + diag(ds);
    y0              = [1; -S(2:L,2:L)\S(2:L,  1); 0];
    yL              = [0; -S(2:L,2:L)\S(2:L,L+1); 1];
    kappa0          = sqrt( y0' * S * y0 );
    kappaL          = sqrt( yL' * S * yL );
    rho             = (yL' * S * y0) / (kappa0 * kappaL);
    if( abs(rho) > sin(alpha) )
        delta           = - kappa0/kappaL * rho;
    else
        delta           = - kappa0/kappaL * sin(alpha)/( alpha + pi/4 * ( sign(rho) + 1 ) - acos(rho) );
    end
    y0              = y0 + delta * yL;
    tau             = -y0(2:(L+1),1);
    beta            = sqrt( y0' * S * y0 );
    if(imag(beta)~=0)
        S(1,1)          = r(:,1)'*r(:,1);
        beta            = sqrt( y0' * S * y0 );
    end
end