% script_run_testcases

% written by Martin Neuenhofen
% runs all test cases from my master's thesis.
%
% If you use these codes or adaptions for numerical experiments then please
% cite the references of the respective test cases (Matrix market, Norris,
% van Gijzen et al., Davis at al.).

% 1. Testcases for single systems

% 1.1 without preconditioning
Testcase01_BiCGstabL_xpl1_v2();
Testcase02_BiCGstabL_xpl3_v2();
Testcase03_Sherman5_v2();
Testcase04_CDR_2Da_v2();
Testcase05_CDR_2Db_v2();
Testcase06_CDR_2Dc_v2();
Testcase07_CDR_2Dd_v2();

% 1.2 with preconditioning
Testcase08_CDR_3Dprec_v2();
Testcase09_Norris_torso1_v2();
Testcase10_Sandia_ASIC320ks_v2();


% 2. Testcases for sequences of systems

% 2.1 without preconditioning
Testcase11_CDR_2Da_v4();
Testcase12_CDR_2Db_v4();
Testcase13_CDR_2Dc_v4();
Testcase14_CDR_2Dd_v4();
Testcase15_CDR_3D_v3();

% 2.2 with preconditioning
Testcase16_CDR_2Dd_prec_v4();
Testcase17_Ocean_v1();