function [cSolver] = makeSolver(myTestcase,sName)
    
    % parameters
    GRAY    = 1-0.5.^[0:2];                                                 %#ok<NBRAK>
    
    % set name
    cSolver.sName       = sName;
    
    % set default parameters
    switch sName
        case 'GMRES'
            cSolver.param                           = [];
            cSolver.plotparam.LineStyle             = '-';
            cSolver.plotparam.LineWidth             = 3;
            cSolver.plotparam.Color                 = GRAY(3)*[1,1,1];
            
        case 'IDRref'
            cSolver.param                           = [];
            cSolver.plotparam.LineStyle             = '--';
            cSolver.plotparam.LineWidth             = 0.5;
            cSolver.plotparam.Color                 = [1 0 0];
            
        case 'IDRbiortho'
            cSolver.param                           = [];
            cSolver.plotparam.LineStyle             = '--';
            cSolver.plotparam.LineWidth             = 0.5;
            cSolver.plotparam.Color                 = [0 0 1];
            
        case 'IDRobio'
            cSolver.param                           = [];
            cSolver.plotparam.LineStyle             = '--';
            cSolver.plotparam.LineWidth             = 0.5;
            cSolver.plotparam.Color                 = [0 0.7 0];
            
        case 'IDRstabref'
            cSolver.param                           = [];
            cSolver.plotparam.LineStyle             = '-';
            cSolver.plotparam.LineWidth             = 0.5;
            cSolver.plotparam.Color                 = [1 0 0];
            
        case 'IDRstabbiortho'
            cSolver.param                           = [];
            cSolver.plotparam.LineStyle             = '-';
            cSolver.plotparam.LineWidth             = 0.5;
            cSolver.plotparam.Color                 = [0 0 1];
            
        case 'IDRstabobio'
            cSolver.param                           = [];
            cSolver.plotparam.LineStyle             = '-';
            cSolver.plotparam.LineWidth             = 0.5;
            cSolver.plotparam.Color                 = [0 0.7 0];
            
        case 'GMstab'
            cSolver.param                           = [];
            cSolver.plotparam.LineStyle             = '-';
            cSolver.plotparam.LineWidth             = 0.5;
            cSolver.plotparam.Color                 = 'black';    % dark green
            
    end %switch
    
    % use different marker symbol when this graph shows the convergence of
    % a subsequent right-hand side
    cSolver.plotparam.MarkerSize            = 4;
    cSolver.plotparam.MarkerEdgeColor   	= cSolver.plotparam.Color;
    cSolver.plotparam.MarkerFaceColor       = cSolver.plotparam.Color;
    switch myTestcase.indexSystems
        case 1
            % do nothing
            cSolver.plotparam.Marker                = '';
        case 2
            cSolver.plotparam.Marker                = 's';
        case 3
            cSolver.plotparam.Marker                = 'o';
            
    end %switch
    
end